unit joystick;

{Unit for joystick in PASCAL by Bernard Lidicky , HIPPO GAMES 1997}

INTERFACE

function JoyX (c : integer) : word;
{Vraci X-ovou souradnici joistiku. c = cislo j. (1,2)}

function JoyY (c : integer) : word;
{Vraci Y-ovou souradnici joistiku. c = cislo j. (1,2)}

function JoyPressA (c : integer) : boolean;
{Zjistuje, zda je stisknut A }

function JoyPressB (c : integer) : boolean;
{Zjistuje, zda je stisknut B }

procedure JoyStatus ( c : integer; A,B : boolean; X,Y : word);
{Zjistuje celkovy stav joystiku.}

IMPLEMENTATION

{---------------------------------------------------------------------------}

uses dos,crt;

function DcBn(i : word;n : integer) : char;
  var k,c  : word;
      vysl : string;
 begin
   c:=i;
   k:=128;
   vysl:='';
   repeat
    if (c>=k) then begin
                     c:=c-k;
                     vysl:=vysl+'1';
                   end
              else vysl:=vysl+'0';
    k:=k div 2;
   until k=0;
   DcBn := vysl[n];
 end;

{---------------------------------------------------------------------------}

function JoyX;
var reg : registers;
begin
  reg.ah := $84;
  reg.dx := 1;
  intr($15,reg);
  case c of
    1 : JoyX := reg.ax;
    2 : Joyx := reg.cx;
  end;
end;

{---------------------------------------------------------------------------}

function JoyY (c : integer) : word;
var reg : registers;
begin
  reg.ah := $84;
  reg.dx := 1;
  intr($15,reg);
  case c of
    1 : JoyY := reg.bx;
    2 : JoyY := reg.dx;
  end;
end;

{---------------------------------------------------------------------------}

function JoyPressA (c :integer) : boolean;
var reg : registers;
begin
  reg.ah := $84;
  reg.dx := 0;
  intr($15,reg);
  JoyPressA := false;
  case c of
    1 : if dcbn(reg.al,3) = '0' then JoyPressA := true;
    2 : if dcbn(reg.al,1) = '0' then JoyPressA := true;
  end;
end;

{---------------------------------------------------------------------------}

function JoyPressB (c :integer) : boolean;
var reg : registers;
begin
  reg.ah := $84;
  reg.dx := 0;
  intr($15,reg);
  JoyPressB := false;
  case c of
    1 : if dcbn(reg.al,4) = '0' then JoyPressB := true;
    2 : if dcbn(reg.al,2) = '0' then JoyPressB := true;
  end;
end;

{---------------------------------------------------------------------------}

procedure JoyStatus ( c : integer; A,B : boolean; X,Y : word);
var reg : registers;
begin
  reg.ah := $84;
  reg.dx := 1;
  intr($15,reg);
  case c of
    1  : begin
         X := reg.ax;
         Y := reg.bx;
         end;
    2  : begin
         x := reg.cx;
         Y := reg.dx;
         end;
  end;

  reg.ah := $84;
  reg.dx := 0;
  intr($15,reg);
  A := false;
  B := false;
  case c of
    1  :  begin
          if dcbn(reg.al,3) = '0' then A := true;
          if dcbn(reg.al,4) = '0' then B := true;
          end;
    2  :  begin
          if dcbn(reg.al,1) = '0' then A := true;
          if dcbn(reg.al,2) = '0' then B := true;
          end;
  end;
end;

end.
